<template>
    <div class="sg-page-content">
        <section class="product-details">
            <div class="container">
                <details-view :productDetails="productDetails"></details-view>
            </div><!-- /.container -->
        </section><!-- /.product-details -->
        <section class="products-section"
                 v-if="productDetails.related_products && productDetails.related_products.length > 0">
            <div class="container">
                <div class="title justify-content-between">
                    <h1>{{lang.related_products}}</h1>
                </div>
                <product :products="productDetails.related_products" :grid_class="'grid-6'"></product>
            </div><!-- /.container -->
        </section>

        <div class="container" v-if="relateds.length>0">

<h1 v-if="relateds.length>0">Related Products:</h1>
  <ul class="products grid-33" v-if="relateds.length>0">
          <li  v-for="(product, index) in relateds" :key="index">
              <div class="sg-product" :class="{ 'style-1': type == 'flash' }">
                  <a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
                      <div class="product-thumb">
                          <div class="span_container" style="min-height: 40px !important;">
                              <span>
                                  <span class="base new">New</span>
                                  <span class="base reword-badge" v-if="addons.includes('reward') && product.reward > 0">
                                      Reward: {{ product.reward }}
                                  </span>
                              </span>
                              <span v-if="authUser">
                                  <span class="favorite_span" v-if="$store.getters.isThisWishlisted(product.id)">
                                      <a href="javaScript:void(0)" @click="removeWishlist(product.id)">
                                          <span class="mdi mdi-name mdi-heart"></span>
                                      </a>
                                  </span>
                                  <span class="favorite_span" v-else>
                                      <a href="javaScript:void(0)" :class="{ 'disable_btn' :  is_disabled == true }" @click="addToWishlist(product.id)">
                                          <span class="mdi mdi-name mdi-heart-outline"></span>
                                      </a>
                                  </span>
                              </span>
                          </div>
                          <!-- <span class="base" v-if="product.special_discount_check > 0">{{ product.special_discount_type == "flat" ? priceFormat(product.special_discount_check) + " " + lang.off : product.special_discount_check + "% " + lang.off }} </span> -->
                          <!-- <span v-if="product.current_stock == 0 && !product.is_classified" class="base stock_badge">{{ lang.out_of_stock }}</span> -->
                          <!-- <span class="base reword-badge" v-if="addons.includes('reward') && product.reward > 0">{{ lang.reward_point }}: {{ product.reward }}</span> -->
                          <img :src="product.image" :alt="product.product_name" class="img-fluid" loading="lazy" style="object-fit: cover;width: 100%;height: 100%"/>
                      </div>
                  </a>
                  <div class="product-info">
                      <h1 class="product-name text-ellipse-one" :title="product.product_name">
                          <a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
                              {{ product.title }}
                          </a>
                      </h1>
                      <span class="price">
                          <div v-if="product.special_discount_check > 0">
                              <span>
                              {{ priceFormat(product.discount_price) }}
                              </span>
                              <div class="discount_style">
                                  <del>{{ priceFormat(product.price) }} </del>
                                  <span class="base discount">
                                      {{ product.special_discount_type == 'flat' ? priceFormat(product.special_discount_check) + ' '+lang.off : product.special_discount_check + '% '+lang.off }} 
                                  </span>
                              </div>
                          </div>
                          <span v-else>{{ priceFormat(product.price) }}</span>
                      </span>



                      <!-- <span class="base" >{{ product.special_discount_type == "flat" ? priceFormat(product.special_discount_check) + " " + lang.off : product.special_discount_check + "% " + lang.off }} </span> -->
                      <!-- <span class="price">
                          <del >{{ priceFormat(product.price) }}</del>
                          <span class="discount_style" >
                              {{ priceFormat(product.discount_percentage) }}
                          </span>
                          <span >{{ priceFormat(product.price) }}</span>
                      </span> -->
                      <!-- <h1 class="product-name text-ellipse-one" :title="product.product_name">
                          <a :href="getUrl('product/' + product.slug)" @click.prevent="routerNavigator('product.details', product.slug)">
                              {{ product.product_name }}
                          </a>
                      </h1> -->
                      <div class="icons">
                          <div class="inner_icon_container">
                              <div class="sg-rating" v-if="!addons.includes('ishopet')">
                                  <!-- <star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating> -->
                                  <div style="display:flex !important;flex-direction: row-reverse !important;gap:6px !important" class="rev" v-if="product.reviews_count > 0">
                                      <div v-if="product.reviews_count > 0"><span>({{product.reviews_count}} reviews)</span></div>
                                      <div class="rat_father">
                                          <div class="starrr"></div>
                                          <span class="rat_num" style="font-size:14px !important">{{ product.rating }}</span>
                                      </div>
                                  </div>
                              </div>
                              <ul class="global-list">
                                  <li>
                                      <a href="javaScript:void(0)" @click="productFetch(product.slug)">
                                          <span class="mdi mdi-name mdi-magnify"> <Search/></span>
                                      </a>
                                  </li>
                                  <li>
                                      <a href="javascript:void(0);" @click="cartBtn(product, index)">
                                          
                                          <span class="mdi mdi-name mdi-shopping-outline"><Bag/></span>
                                      </a>
                                  </li>
                              </ul>
                          </div>
                      </div>
                      <div class="sg-rating" v-if="!addons.includes('ishopet')">
                          <star-rating v-model:rating="product.rating" :read-only="true" :star-size="12" :round-start-rating="false"></star-rating>
                              <span class="reviews" v-if="product.reviews_count > 0">({{ product.reviews_count }} {{ lang.reviews }})</span>
                      </div>
                      <ul class="global-list">
                          <li>
                              <a href="javaScript:void(0)" @click="productFetch(product.slug)">
                                  <span class="mdi mdi-name mdi-magnify"> <Search/></span>
                              </a>
                          </li>
                          <li>
                              <a href="javascript:void(0);" @click="cartBtn(product, index)">
                                  
                                  <span class="mdi mdi-name mdi-shopping-outline"><Bag/></span>
                              </a>
                          </li>
                      </ul>
                      <div class="buttons d-flex align-items-center justify-content-center mt-1'">
                          <a href="javascript:void(0);" @click="cartBtn(product, index)" class="btn btn-primary"><svg xmlns="http://www.w3.org/2000/svg" id="Outline" viewBox="0 0 24 24" width="42" height="42"><path d="M21,6H18A6,6,0,0,0,6,6H3A3,3,0,0,0,0,9V19a5.006,5.006,0,0,0,5,5H19a5.006,5.006,0,0,0,5-5V9A3,3,0,0,0,21,6ZM12,2a4,4,0,0,1,4,4H8A4,4,0,0,1,12,2ZM22,19a3,3,0,0,1-3,3H5a3,3,0,0,1-3-3V9A1,1,0,0,1,3,8H6v2a1,1,0,0,0,2,0V8h8v2a1,1,0,0,0,2,0V8h3a1,1,0,0,1,1,1Z"></path></svg>
                          </a>
                          <div class="zzz">
                              <svg width="29" height="29" viewBox="0 0 29 29" fill="none" xmlns="http://www.w3.org/2000/svg">
                                  <path d="M9.77757 5.8C7.36049 5.8 5.39404 7.76764 5.39404 10.1861C5.39404 10.5221 5.66626 10.7945 6.00197 10.7945C6.33773 10.7945 6.60989 10.5221 6.60989 10.1861C6.60989 8.43844 8.03089 7.01659 9.77757 7.01659C10.1133 7.01659 10.3855 6.74426 10.3855 6.40827C10.3855 6.07233 10.1133 5.8 9.77757 5.8Z" fill="#660F1F"/>
                                  <path d="M20.4845 17.0778C21.5834 15.3539 22.2202 13.3086 22.2202 11.1167C22.2202 4.98641 17.2368 0 11.1101 0C8.91948 0 6.87538 0.637207 5.15254 1.73677C3.77986 2.61244 2.6117 3.78127 1.73655 5.15475C0.637604 6.87866 0 8.92475 0 11.1167C0 17.2462 4.98426 22.2333 11.1101 22.2333C13.3007 22.2333 15.3456 21.5953 17.0685 20.4957C18.4412 19.6201 19.6093 18.4512 20.4845 17.0778ZM14.7129 18.1387C13.6324 18.6962 12.4071 19.0111 11.1101 19.0111C6.76029 19.0111 3.2203 15.4691 3.2203 11.1167C3.2203 9.81893 3.53511 8.59289 4.09223 7.51185C4.84657 6.04735 6.04537 4.84866 7.50896 4.09466C8.58938 3.53721 9.8139 3.22223 11.1101 3.22223C15.4607 3.22223 18.9999 6.76346 18.9999 11.1167C18.9999 12.4136 18.6851 13.6389 18.1279 14.7199C17.3745 16.1844 16.1765 17.3839 14.7129 18.1387Z" fill="#660F1F"/>
                                  <path d="M28.2929 24.874L21.8788 18.4722C20.9658 19.8062 19.7961 20.9758 18.4629 21.8902L24.8769 28.2919C25.3487 28.764 25.967 29 26.5845 29C27.2028 29 27.8212 28.764 28.2929 28.2919C29.2357 27.3478 29.2357 25.818 28.2929 24.874Z" fill="#660F1F"/>
                              </svg>
                          </div>
                      
                      </div>
                      <div class="icons">
                          <ul class="global-list">
                              <li v-if="product.minimum_order_quantity <= product.current_stock && !product.is_catalog && !product.is_classified" >
                                  <a href="javaScript:void(0)" @click="cartBtn(product, index)"><span class="mdi mdi-name mdi-shopping-outline"></span></a>
                              </li>
                              <div v-if="authUser">
                                  <li v-if="$store.getters.isThisWishlisted(product.id)">
                                      <a href="javaScript:void(0)" @click="removeWishlist(product.id)"><span class="mdi mdi-name mdi-heart"></span></a>
                                  </li>
                                  <li v-else>
                                      <a href="javaScript:void(0)" :class="{ disable_btn: is_disabled == true }" @click="addToWishlist(product.id)"><span class="mdi mdi-name mdi-heart-outline"></span></a>
                                  </li>
                              </div>
                              <!-- <li v-if="compareCheck(product)">
                                  <a class="active_compare" :class="{ disable_btn: is_disabled == true }" @click="removeCompare(product.id)" href="javaScript:void(0)"><span class="mdi mdi-name mdi-scale-balance"></span></a>
                              </li> -->
                              <li v-else>
                                  <a @click="addToCompare(product)" :class="{ disable_btn: is_disabled == true }" href="javaScript:void(0)"><span class="mdi mdi-name mdi-scale-balance"></span></a>
                              </li>
                              <li>
                                  <a href="javaScript:void(0)" @click="productFetch(product.slug)"><span class="mdi mdi-name mdi-magnify"></span></a>
                              </li>
                          </ul>
                      </div>
                  </div>
              </div><!-- /.sg-product -->
          </li>
      </ul>
</div>
    </div>
</template>

<script>

import product from "./product";
import detailsView from "../partials/details-view";

export default {
    name: "product-details",
    components: {product, detailsView},
    data() {
        return {
            hours: 0,
            minutes: 0,
            seconds: 0,
            relateds:[],
            slug:{
              product_slug: this.$route.params.slug
            }

        }

    },
    watch: {
        $route() {
          let set_params = {
            slug: this.$route.params.slug,
            referral_code : this.$route.query.referral_code
          }
            if (!this.productDetails) {
                this.$store.dispatch('productDetails', set_params);
            }
        }
    },
    mounted() {
        this.loadRelated();
      let set_params = {
        slug: this.$route.params.slug,
        referral_code : this.$route.query.referral_code
      }
      this.$store.dispatch('productView',this.slug);
        if (!this.productDetails) {
            this.$store.dispatch('productDetails', set_params);
        }

    },
    computed: {
        productDetails() {
            let products = this.$store.getters.getProductDetails;
            for (let i = 0; i < products.length; i++) {
                if (products[i].slug == this.$route.params.slug) {
                    if (products[i].product.status != 'published')
                    {
                        toastr.warning(products[i].product.product_name + this.lang.is_unavailable_at_this_moment, this.lang.Warning +' !!' );

                        return this.$router.go(-1);
                    }
                    return products[i].product;
                }
            }

            return false;
        },
    },
    methods: {
        loadRelated(){
            let url = this.getUrl(`api/v100/products/${this.$route.params.slug}/related_products/`);
                axios.get(url).then((response) => {
                    this.disable = false;
                    if (response.data.error) {
                        toastr.error(response.data.error, this.lang.Error + " !!");
                    } else {
                this.relateds=response.data.data
                console.log(this.relateds,'iiiuux');
                }
            });
        },
        countDownTimer() {
            const now = new Date().getTime();
            // let startOfDay = new Date(now - (now % 86400000)).toUTCString();
            let end_time = new Date(now - (now % 86400000) + 86400000); //2022-12-25 09:33:00
            let final_end_time = '';
            final_end_time += end_time.getFullYear() + '-';
            final_end_time += end_time.getMonth() + 1 + '-';
            final_end_time += end_time.getDate() - 1 + ' ';
            final_end_time += '23:';
            final_end_time += '59:';
            final_end_time += '59';
            return final_end_time;
        },

    }
}
</script>
